/*
 * BQ.h
 *
 *  Created on: 04.11.2015
 *      Author: XPMUser
 */

#ifndef BQ_H_
#define BQ_H_

#define OUTPUTMODE_TABLE	1



int64_t DBL_2_I64(double val);
double I64_2_DBL(int64_t val);
int32_t DBL_2_I32(double val);
double I32_2_DBL(int32_t val);
double  ABS_DBL(double val);
double DBL_2_32LSBs(double val);
uint32_t NumOfBits(int64_t NUM);


int32_t singen_24Bit_I32(double f0,double gain, double fs, int32_t timestep);
int64_t singen_24Bit_I64(double f0,double gain, double fs, int32_t timestep);
double singen_24Bit_DBL(double f0,double gain, double fs, int32_t timestep);
double singen_multi_DBL(double fs, int32_t timestep,
						double f1,double phase1, double gain1,
						double f2,double phase2, double gain2,
						double f3,double phase3, double gain3);

void DPQB(int64_t datain,uint32_t datapreshift,int32_t a1,int32_t a2,int32_t b0,int32_t b1,int32_t b2,
		  int64_t *D1,int64_t *D2,int64_t *Dy1,int64_t *Dy2,
		  int64_t *Res64	);
void SPQB(int32_t datain,uint32_t datapreshift,int32_t a1,int32_t a2,int32_t b0,int32_t b1,int32_t b2,
		  int32_t *D1,int32_t *D2,int32_t *Dy1,int32_t *Dy2,uint32_t *Nshape,uint32_t *Nshape2,
		  int32_t *Res32, uint32_t bool_Nshape	);

// b0..b2=32BIT, a1,a2=DP
void DPSPQB(int32_t datain,uint32_t datapreshift,int32_t a1,int32_t a2,int32_t b0,int32_t b1,int32_t b2,
		  int32_t *D1,int32_t *D2,
		  int32_t *Dy1H,uint32_t *Dy1L,
		  int32_t *Dy2H,uint32_t *Dy2L,
		  int64_t *Res64);
void FLTBQ(float datain,uint32_t datapreshift,int32_t a1,int32_t a2,int32_t b0,int32_t b1,int32_t b2,
		   float *D1,float *D2,float *Dy1,float *Dy2,
		   float *Resdbl	);
void DBLBQ(double datain,uint32_t datapreshift,int32_t a1,int32_t a2,int32_t b0,int32_t b1,int32_t b2,
		   double *D1,double *D2,double *Dy1,double *Dy2,
		   double *Resdbl	);
void DBLBQ_PEAK(double datain,uint32_t datapreshift,int32_t a1,int32_t a2,int32_t b0,int32_t b1,int32_t b2,
		   double *D1,double *D2,double *Dy1,double *Dy2,
		   double *Resdbl, double *PeakAkku, double *PeakOut	);



void DPQB(int64_t datain,uint32_t datapreshift,int32_t a1,int32_t a2,int32_t b0,int32_t b1,int32_t b2,
		  int64_t *D1,int64_t *D2,int64_t *Dy1,int64_t *Dy2,
		  int64_t *Res64	);
void SPQB(int32_t datain,uint32_t datapreshift,int32_t a1,int32_t a2,int32_t b0,int32_t b1,int32_t b2,
		  int32_t *D1,int32_t *D2,int32_t *Dy1,int32_t *Dy2,uint32_t *Nshape,uint32_t *Nshape2,
		  int32_t *Res32, uint32_t bool_Nshape	);

// b0..b2=32BIT, a1,a2=DP
void DPSPQB(int32_t datain,uint32_t datapreshift,int32_t a1,int32_t a2,int32_t b0,int32_t b1,int32_t b2,
		  int32_t *D1,int32_t *D2,
		  int32_t *Dy1H,uint32_t *Dy1L,
		  int32_t *Dy2H,uint32_t *Dy2L,
		  int64_t *Res64);
void FLTBQ(float datain,uint32_t datapreshift,int32_t a1,int32_t a2,int32_t b0,int32_t b1,int32_t b2,
		   float *D1,float *D2,float *Dy1,float *Dy2,
		   float *Resdbl	);





// in BQ_TEST.c
void TEST_BitSizeMul(double sin_f, double sin_gain,double coeff_1,double coeff_2,double coeff_3,double coeff_4,double coeff_5);

void TEST_AKKUPEAK(double coeff_1,double coeff_2,double coeff_3,double coeff_4,double coeff_5,
				  double f1,double phase1, double gain1,
				  double f2,double phase2, double gain2,
				  double f3,double phase3, double gain3);

#endif /* BQ_H_ */
